/* $Id: eximstated.h.in,v 1.3 2002/08/21 15:42:39 ollie Exp $ */
#ifndef EXIMSTATED
#define EXIMSTATED

#define CONF_FILE "/usr/local/etc/eximstated.conf"

/* Further Includes */
#include "config.h"

struct client {
	int fd; /* File descriptor */
	char inbuf[MAX_BUF]; /* Input buffer */
	int ipos; /* Position in input buffer */
	int ready;  /* Has end of line been reached? Is all data received */
	int disconnect; /* OK to disconnect? */
	struct sockaddr_in address; /* Address structure of connecting client */
	struct client *next; /* Pointer to next client */
	struct client *prev; /* Pointer to previous client */
	char identity[MAX_BUF]; /* Client Identity */
	time_t lastcommand; /* Time last command received */
};

struct config {
	char pid_file[MAX_BUF];
	char data_dir[MAX_BUF];
	int port;
	time_t timeout;
};

struct command_list {
	char command[MAX_BUF];
	struct command_list *next;
};

struct client *add_new_connection (fd_set socks, int highest_sock, int listen_sock, struct client **latest_client);
void disconnect_client (struct client *client, struct client **latest_client);
void display_list (struct client *latest_client);
void read_socket (fd_set socks, struct client *client);
void action_command (struct client *client, struct client **latest_client, char *command);
struct command_list *split_to_commands (char* command_string);
void destroy_command_list (struct command_list *cmd_list);
int setup_state (struct config *config, struct conf_item *first_item);
void sighandler (int sig);

int debugflag;
#endif
